package unit

import (
	"bytes"
	"encoding/json"
	"fmt"
	"io"
	"net/http"

	sync "simrs-vx/internal/infra/sync-cfg"

	e "simrs-vx/internal/domain/main-entities/unit"
	elog "simrs-vx/internal/domain/sync-entities/log"

	d "github.com/karincake/dodol"
)

func Create(input *e.CreateDto) error {
	endpoint := getPrefixEndpoint()

	jsonData, err := json.Marshal(input)
	if err != nil {
		return fmt.Errorf("failed to encode JSON: %w", err)
	}

	req, err := http.NewRequest("POST", endpoint, bytes.NewReader(jsonData))
	if err != nil {
		return err
	}

	req.Header.Set("Content-Type", "application/json")

	resp, err := http.DefaultClient.Do(req)
	if err != nil {
		return err
	}
	defer resp.Body.Close()

	bodyBytes, err := io.ReadAll(resp.Body)
	if err != nil {
		return err
	}

	if resp.StatusCode != http.StatusOK {
		errors := d.FieldError{}
		_ = json.Unmarshal(bodyBytes, &errors)

		return fmt.Errorf(errors.Message)
	}

	return nil
}

func CreateLog(input *elog.SimxLogDto) error {
	prefixEndpoint := getPrefixEndpoint()
	endpoint := prefixEndpoint + "/log"

	jsonData, err := json.Marshal(input)
	if err != nil {
		return fmt.Errorf("failed to encode JSON: %w", err)
	}

	req, err := http.NewRequest("POST", endpoint, bytes.NewReader(jsonData))
	if err != nil {
		return err
	}

	req.Header.Set("Content-Type", "application/json")

	resp, err := http.DefaultClient.Do(req)
	if err != nil {
		return err
	}
	defer resp.Body.Close()

	bodyBytes, err := io.ReadAll(resp.Body)
	if err != nil {
		return err
	}

	if resp.StatusCode != http.StatusOK {
		errors := d.FieldError{}
		_ = json.Unmarshal(bodyBytes, &errors)

		return fmt.Errorf(errors.Message)
	}

	return nil
}

func Update(input *e.UpdateDto) error {
	prefixEndpoint := getPrefixEndpoint()
	endpoint := fmt.Sprintf("%s/%v", prefixEndpoint, *input.Id)

	jsonData, err := json.Marshal(input)
	if err != nil {
		return fmt.Errorf("failed to encode JSON: %w", err)
	}

	req, err := http.NewRequest("PATCH", endpoint, bytes.NewReader(jsonData))
	if err != nil {
		return err
	}

	req.Header.Set("Content-Type", "application/json")

	resp, err := http.DefaultClient.Do(req)
	if err != nil {
		return err
	}
	defer resp.Body.Close()

	bodyBytes, err := io.ReadAll(resp.Body)
	if err != nil {
		return err
	}

	if resp.StatusCode != http.StatusOK {
		errors := d.FieldError{}
		_ = json.Unmarshal(bodyBytes, &errors)

		return fmt.Errorf(errors.Message)
	}

	return nil
}

func Delete(input *e.DeleteDto) error {
	prefixEndpoint := getPrefixEndpoint()
	endpoint := fmt.Sprintf("%s/%v", prefixEndpoint, *input.Id)

	jsonData, err := json.Marshal(input)
	if err != nil {
		return fmt.Errorf("failed to encode JSON: %w", err)
	}

	req, err := http.NewRequest("DELETE", endpoint, bytes.NewReader(jsonData))
	if err != nil {
		return err
	}

	req.Header.Set("Content-Type", "application/json")

	resp, err := http.DefaultClient.Do(req)
	if err != nil {
		return err
	}
	defer resp.Body.Close()

	bodyBytes, err := io.ReadAll(resp.Body)
	if err != nil {
		return err
	}

	if resp.StatusCode != http.StatusOK {
		errors := d.FieldError{}
		_ = json.Unmarshal(bodyBytes, &errors)

		return fmt.Errorf(errors.Message)
	}

	return nil
}

func getPrefixEndpoint() string {
	return fmt.Sprintf("%s%s/v1/unit", sync.O.Host, sync.O.Prefix)
}
